local Semicombat;
local Semiraid;
--SF_Player_Locked = true;
--SF_Target_Locked = true;
SF_TargetofTarget_Locked = true;

SF_Castbar_State = true;
SF_Gryphon_State = true;
SF_Bags_State = true;
SF_MicroMenu_State = true;
SF_MainMenuBarTexture_State = true;
SF_ActionPageButtons_State = false;
SF_Party_State = true;
SF_Raid_State = false;
SF_EB_1_State = true;
SF_EB_2_State = true;
SF_EB_3_State = true;

Semi_Player_Scale = 1.0;
Semi_Pet_Scale = 1.0;
Semi_Target_Scale = 1.0;
Semi_ToT_Scale = 1.0;
Semi_AllBars_Scale = 1.0;
Semi_PetBar_Scale = 1.0;
Semi_TotemBar_Scale = 1.0;
Semi_Support_PlayerXPBar_Scale = 1.0;
Semi_PartyFrame_Scale = 1.0;
Semi_FocusFrame_Scale = 1.0;
Semi_BossTargetFrame_Scale = 1.0;

local Semiclass = UnitClass("player");
local Semilevel = UnitLevel("player");

function Semi_Core_OnLoad()
		--Setting Inital Text for Menu
	Semi_CoreOptionsTitle:SetText(Semi_Core_String_Version);
	if (SF_Bags_State) then
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
	elseif (not SF_Bags_State) then
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
	end
	if (SF_MicroMenu_State) then
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
	elseif (not SF_MicroMenu_State) then
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
	end
	if (SF_MainMenuBarTexture_State) then
		Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12a);
	elseif (not SF_MainMenuBarTexture_State) then
		Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12b);
	end
	if (SF_ActionPageButtons_State) then
		Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13a);
	elseif (not SF_ActionPageButtons_State) then
		Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13b);
	end
	if (SF_Party_State) then
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a);
	elseif (not SF_Party_State) then
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b);
	end
	
	if (SF_Raid_State) then
		Semi_CoreOptionsCheckButton11Text:SetText(Semi_Core_String_CB11a);
	elseif (not SF_Raid_State) then
		Semi_CoreOptionsCheckButton11Text:SetText(Semi_Core_String_CB11b);
	end
	
	if (SF_Castbar_State) then
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
	elseif (not SF_Castbar_State) then
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
	end
	if (SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
	elseif (not SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
	end
	
	Semi_CoreOptionsButton1:SetText(Semi_Core_String_B1);
	Semi_CoreOptionsButton2:SetText(Semi_Core_String_B2);
	Semi_CoreOptionsButton3:SetText(Semi_Core_String_B3);
	Semi_CoreOptionsButton4:SetText(Semi_Core_String_B4);
	
		--Setting Inital Text for Modules Menu
	Semi_CoreOptions_ModsTitle:SetText(Semi_Core_Mods_String_Title);
	Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9a);
	Semi_CoreOptions_ModsButton1:SetText(Semi_Core_Mods_String_B1);
	Semi_CoreOptions_ModsButton2:SetText(Semi_Core_Mods_String_B2);
	Semi_CoreOptions_ModsButton3:SetText(Semi_Core_Mods_String_B3);
					
end

function Semi_CoreOptions_OnShow()
	if (IsAddOnLoaded("Semi_Action_Bars")) then
		if (SF_Bags_State) then
			Semi_CoreOptionsCheckButton1:SetChecked(true);
			Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
		end
		if (not SF_Bags_State) then
			Semi_CoreOptionsCheckButton1:SetChecked(false);
			Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
		end
		if (SF_MicroMenu_State) then
			Semi_CoreOptionsCheckButton2:SetChecked(true);
			Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
		end
		if (not SF_MicroMenu_State) then
			Semi_CoreOptionsCheckButton2:SetChecked(false);
			Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
		end
		if (SF_MainMenuBarTexture_State) then
			Semi_CoreOptionsCheckButton12:SetChecked(true);
			Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12a);
		end
		if (not SF_MainMenuBarTexture_State) then
			Semi_CoreOptionsCheckButton12:SetChecked(false);
			Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12b);
		end
		if (SF_ActionPageButtons_State) then
			Semi_CoreOptionsCheckButton13:SetChecked(true);
			Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13a);
		end
		if (not SF_ActionPageButtons_State) then
			Semi_CoreOptionsCheckButton13:SetChecked(false);
			Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13b);
		end
	end
	if (SF_Party_State) then
		Semi_CoreOptionsCheckButton3:SetChecked(true);
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a);
	elseif (not SF_Party_State) then
		Semi_CoreOptionsCheckButton3:SetChecked(false);
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b);
	end
	
	if (SF_Raid_State) then
		Semi_CoreOptionsCheckButton11:SetChecked(true);
		Semi_CoreOptionsCheckButton11Text:SetText(Semi_Core_String_CB11a);
	elseif (not SF_Raid_State) then
		Semi_CoreOptionsCheckButton11:SetChecked(false);
		Semi_CoreOptionsCheckButton11Text:SetText(Semi_Core_String_CB11b);
	end
	
	if (not IsAddOnLoaded("Semi_Action_Bars")) then
			Semi_CoreOptionsCheckButton1:Disable();
			Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1c);
			Semi_CoreOptionsCheckButton2:Disable();
			Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2c);
			Semi_CoreOptionsCheckButton12:Disable();
			Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12c);
			Semi_CoreOptionsCheckButton13:Disable();
			Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13c);
	end	
	

	
	if (SF_Castbar_State) then
		Semi_CoreOptionsCheckButton4:SetChecked(true);
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
	else
		Semi_CoreOptionsCheckButton4:SetChecked(false);
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
	end
	if (SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5:SetChecked(true);
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
	else
		Semi_CoreOptionsCheckButton5:SetChecked(false);
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
	end
	
	if (IsAddOnLoaded("Semi_Extra_Bars")) then
		SF_EB_Vehicle_Alpha_State = Semi_Show_Bars_In_Vehicle;
		
		Semi_CoreOptionsCheckButton6:SetChecked(SF_EB_1_State);
		if (SF_EB_1_State) then 
			Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6a);
		end
		if (not SF_EB_1_State) then
			Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6b);
		end
		
		Semi_CoreOptionsCheckButton7:SetChecked(SF_EB_2_State);
		if (SF_EB_2_State) then
			Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7a);
		end
		if (not SF_EB_2_State) then
			Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7b);
		end
		
		Semi_CoreOptionsCheckButton8:SetChecked(SF_EB_3_State);
		if (SF_EB_3_State) then
			Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8a);
		end
		if (not SF_EB_3_State) then
			Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8b);
		end
		Semi_CoreOptionsCheckButton9:SetChecked(Semi_Grid);
		if (Semi_Grid) then
			Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9a);
		end
		if (not Semi_Grid) then
			Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9b);
		end
		Semi_CoreOptionsCheckButton10:SetChecked(SF_EB_Vehicle_Alpha_State);
		if (SF_EB_Vehicle_Alpha_State) then
			Semi_CoreOptionsCheckButton10Text:SetText(Semi_Core_String_CB10a);
		end
		if (not SF_EB_Vehicle_Alpha_State) then
			Semi_CoreOptionsCheckButton10Text:SetText(Semi_Core_String_CB10b);
		end
	end
	if (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptionsCheckButton6:Disable();
		Semi_CoreOptionsCheckButton6:Hide();
		Semi_CoreOptionsCheckButton7:Disable();
		Semi_CoreOptionsCheckButton7:Hide();
		Semi_CoreOptionsCheckButton8:Disable();
		Semi_CoreOptionsCheckButton8:Hide();
		Semi_CoreOptionsCheckButton9:Disable();
		Semi_CoreOptionsCheckButton9:Hide();
		Semi_CoreOptionsCheckButton10:Disable();
		Semi_CoreOptionsCheckButton10:Hide();
	end
end

function Semi_CoreOptions_Mods_OnShow()
	if (not IsAddOnLoaded("Semi_Boss_Frames")) then
 		Semi_CoreOptions_ModsCheckButton1:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1b);
	else 
		Semi_CoreOptions_ModsCheckButton1:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	end
	--if (not IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2b);
	--else
		--Semi_CoreOptions_ModsCheckButton2:SetChecked(true);
		--Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	--end
	if (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3b);
	else
		Semi_CoreOptions_ModsCheckButton3:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	end
	if (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4b);
	else
		Semi_CoreOptions_ModsCheckButton4:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	end
	if (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5b);
	else
		Semi_CoreOptions_ModsCheckButton5:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	end
	
	if (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6b);
	else
		Semi_CoreOptions_ModsCheckButton6:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	end
	
	if (not IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7b);
	else
		Semi_CoreOptions_ModsCheckButton7:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	end
	
	if (not IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8b);
	else
		Semi_CoreOptions_ModsCheckButton8:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	end
	
	if (not IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9b);
	else
		Semi_CoreOptions_ModsCheckButton9:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9a);
	end
	
end

function Semi_ScaleOptions_OnShow()
	Semi_ScaleOptionsTitle:SetText(Semi_Scale_String_Title);
	Semi_ScaleOptionsButton3Text:SetText(Semi_Scale_String_B3);
	Semi_ScaleOptionsButton4Text:SetText(Semi_Scale_String_B4);
	Semi_PFSlider();
	Semi_PetFSlider();
	Semi_TFSlider();
	Semi_ToTFSlider();
	Semi_PartyScaleSlider();
	Semi_FocusFrameSlider();
	Semi_All_Bars_Slider();
	Semi_PetBar_Slider();
	--if (IsAddOnLoaded("Semi_Boss_Frames")) then
		Semi_BossTargetFrame_Slider();
	--end
	
	if (Semiclass == "Shaman") then
		Semi_TotemBar_Slider();
	end
	if (IsAddOnLoaded("PlayerXPBar")) then
		Semi_Support_PlayerXPBar_Slider();
	end
end

function Semi_PFSlider()
	CreateFrame("Slider", "PlayerFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PlayerFrameScaleSlider:ClearAllPoints();
	PlayerFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -50);
	PlayerFrameScaleSlider:SetMinMaxValues(0.5, 2);
	PlayerFrameScaleSlider:SetValueStep(0.1);
	PlayerFrameScaleSlider:SetValue(Semi_Player_Scale);
	PlayerFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_Player_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_LEFT");
						GameTooltip:SetText(new_value);
						_G[PlayerFrameScaleSlider:GetName().."Text"]:SetText("Player Frame:   "..Semi_Player_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[PlayerFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[PlayerFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[PlayerFrameScaleSlider:GetName().."Text"]:SetText("Player Frame:   "..Semi_Player_Scale);
	PlayerFrameScaleSlider:Show();
end

function Semi_PetFSlider()
	CreateFrame("Slider", "PetFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PetFrameScaleSlider:ClearAllPoints();
	PetFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -100);
	PetFrameScaleSlider:SetMinMaxValues(0.5, 2);
	PetFrameScaleSlider:SetValueStep(0.1);
	PetFrameScaleSlider:SetValue(Semi_Pet_Scale);
	PetFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_Pet_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_LEFT");
						GameTooltip:SetText(new_value);
						_G[PetFrameScaleSlider:GetName().."Text"]:SetText("Pet Frame:   "..Semi_Pet_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[PetFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[PetFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[PetFrameScaleSlider:GetName().."Text"]:SetText("Pet Frame:   "..Semi_Pet_Scale);
	PetFrameScaleSlider:Show();
end

function Semi_TFSlider()
	CreateFrame("Slider", "TargetFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	TargetFrameScaleSlider:ClearAllPoints();
	TargetFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -150);
	TargetFrameScaleSlider:SetMinMaxValues(0.5, 2);
	TargetFrameScaleSlider:SetValueStep(0.1);
	TargetFrameScaleSlider:SetValue(Semi_Target_Scale);
	TargetFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_Target_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_LEFT");
						GameTooltip:SetText(new_value);
						_G[TargetFrameScaleSlider:GetName().."Text"]:SetText("Target Frame:   "..Semi_Target_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[TargetFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[TargetFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[TargetFrameScaleSlider:GetName().."Text"]:SetText("Target Frame:   "..Semi_Target_Scale);
	TargetFrameScaleSlider:Show();
end

function Semi_ToTFSlider()
	CreateFrame("Slider", "TargetofTargetFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	TargetofTargetFrameScaleSlider:ClearAllPoints();
	TargetofTargetFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -200);
	TargetofTargetFrameScaleSlider:SetMinMaxValues(0.25, 3);
	TargetofTargetFrameScaleSlider:SetValueStep(0.05);
	TargetofTargetFrameScaleSlider:SetValue(Semi_ToT_Scale);
	TargetofTargetFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
			new_value = semi_round(value, 2);
			self:SetValue(new_value);
			Semi_ToT_Scale_On_Change(new_value);
			GameTooltip:SetOwner(self, "ANCHOR_LEFT");
			GameTooltip:SetText(new_value);
			_G[TargetofTargetFrameScaleSlider:GetName().."Text"]:SetText("Target of Target:   "..Semi_ToT_Scale);
			GameTooltip:Show();
			GameTooltip:FadeOut();
			end)
	_G[TargetofTargetFrameScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[TargetofTargetFrameScaleSlider:GetName().."High"]:SetText("3");
	_G[TargetofTargetFrameScaleSlider:GetName().."Text"]:SetText("Target of Target:   "..Semi_ToT_Scale);
	TargetofTargetFrameScaleSlider:Show();
end

function Semi_PartyScaleSlider()
	CreateFrame("Slider", "PartyFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PartyFrameScaleSlider:ClearAllPoints();
	PartyFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -250);
	PartyFrameScaleSlider:SetMinMaxValues(0.5, 2);
	PartyFrameScaleSlider:SetValueStep(0.1);
	PartyFrameScaleSlider:SetValue(Semi_PartyFrame_Scale);
	PartyFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_PartyFrame_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_LEFT");
						GameTooltip:SetText(new_value);
						_G[PartyFrameScaleSlider:GetName().."Text"]:SetText("Party Frames:  "..Semi_PartyFrame_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[PartyFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[PartyFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[PartyFrameScaleSlider:GetName().."Text"]:SetText("Party Frames:  "..Semi_PartyFrame_Scale);
	PartyFrameScaleSlider:Show();
end

function Semi_FocusFrameSlider()
	CreateFrame("Slider", "FocusFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	FocusFrameScaleSlider:ClearAllPoints();
	FocusFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -300);
	FocusFrameScaleSlider:SetMinMaxValues(0.5, 2);
	FocusFrameScaleSlider:SetValueStep(0.1);
	FocusFrameScaleSlider:SetValue(Semi_FocusFrame_Scale);
	FocusFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_FocusFrame_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_LEFT");
						GameTooltip:SetText(new_value);
						_G[FocusFrameScaleSlider:GetName().."Text"]:SetText("Focus Frame:  "..Semi_FocusFrame_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[FocusFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[FocusFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[FocusFrameScaleSlider:GetName().."Text"]:SetText("Focus Frame:  "..Semi_FocusFrame_Scale);
	FocusFrameScaleSlider:Show();
	
end

function Semi_BossTargetFrame_Slider()
	CreateFrame("Slider", "BossTargetFramesScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	BossTargetFramesScaleSlider:ClearAllPoints();
	BossTargetFramesScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -350);
	BossTargetFramesScaleSlider:SetMinMaxValues(0.25, 2);
	BossTargetFramesScaleSlider:SetValueStep(0.05);
	BossTargetFramesScaleSlider:SetValue(Semi_BossTargetFrame_Scale);
	BossTargetFramesScaleSlider:SetScript("OnValueChanged", function (self, value)
							new_value = semi_round(value, 2);
							self:SetValue(new_value);
							Semi_BossTargetFrames_Scale_On_Change(new_value);
							GameTooltip:SetOwner(self, "ANCHOR_LEFT");
							GameTooltip:SetText(new_value);
							_G[BossTargetFramesScaleSlider:GetName().."Text"]:SetText("Boss Frames: "..Semi_BossTargetFrame_Scale);
							GameTooltip:Show();
							GameTooltip:FadeOut();
						end)
	_G[BossTargetFramesScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[BossTargetFramesScaleSlider:GetName().."High"]:SetText("2");
	_G[BossTargetFramesScaleSlider:GetName().."Text"]:SetText("Boss Frames: "..Semi_BossTargetFrame_Scale);
	BossTargetFramesScaleSlider:Show();
end

function Semi_All_Bars_Slider()
	CreateFrame("Slider", "AllActionBarsScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	AllActionBarsScaleSlider:ClearAllPoints();
	AllActionBarsScaleSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -50);
	AllActionBarsScaleSlider:SetMinMaxValues(0.25, 2.5);
	AllActionBarsScaleSlider:SetValueStep(0.05);
	AllActionBarsScaleSlider:SetValue(Semi_AllBars_Scale);
	AllActionBarsScaleSlider:SetScript("OnValueChanged", function (self, value)
								new_value = semi_round(value, 2);
								self:SetValue(new_value);
								Semi_All_Bars_Scale_On_Change(new_value);
								GameTooltip:SetOwner(self, "ANCHOR_LEFT");
								GameTooltip:SetText(new_value);
								_G[AllActionBarsScaleSlider:GetName().."Text"]:SetText("All Action Bars:   "..Semi_AllBars_Scale);
								GameTooltip:Show();
								GameTooltip:FadeOut();
							end)
	_G[AllActionBarsScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[AllActionBarsScaleSlider:GetName().."High"]:SetText("2.5");
	_G[AllActionBarsScaleSlider:GetName().."Text"]:SetText("All Action Bars:   "..Semi_AllBars_Scale);
	AllActionBarsScaleSlider:Show();
end

function Semi_PetBar_Slider()
	CreateFrame("Slider", "PetBarScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PetBarScaleSlider:ClearAllPoints();
	PetBarScaleSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -100);
	PetBarScaleSlider:SetMinMaxValues(0.25, 2);
	PetBarScaleSlider:SetValueStep(0.05);
	PetBarScaleSlider:SetValue(Semi_PetBar_Scale);
	PetBarScaleSlider:SetScript("OnValueChanged", function (self, value)
		new_value = semi_round(value, 2);
		self:SetValue(new_value);
		Semi_PetBar_Scale_On_Change(new_value);
		GameTooltip:SetOwner(self, "ANCHOR_LEFT");
		GameTooltip:SetText(new_value);
		_G[PetBarScaleSlider:GetName().."Text"]:SetText("Pet Bar:   "..Semi_PetBar_Scale);
		GameTooltip:Show();
		GameTooltip:FadeOut();
		end)
	_G[PetBarScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[PetBarScaleSlider:GetName().."High"]:SetText("2");
	_G[PetBarScaleSlider:GetName().."Text"]:SetText("Pet Bar:   "..Semi_PetBar_Scale);
	PetBarScaleSlider:Show();
end

function Semi_TotemBar_Slider()
	CreateFrame("Slider", "TotemBarScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	TotemBarScaleSlider:ClearAllPoints();
	TotemBarScaleSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -150);
	TotemBarScaleSlider:SetMinMaxValues(0.25, 2);
	TotemBarScaleSlider:SetValueStep(0.05);
	TotemBarScaleSlider:SetValue(Semi_TotemBar_Scale);
	TotemBarScaleSlider:SetScript("OnValueChanged", function (self, value)
							new_value = semi_round(value, 2);
							self:SetValue(new_value);
							Semi_TotemBar_Scale_On_Change(new_value);
							GameTooltip:SetOwner(self, "ANCHOR_LEFT");
							GameTooltip:SetText(new_value);
							_G[TotemBarScaleSlider:GetName().."Text"]:SetText("Totem Bar:   "..Semi_TotemBar_Scale);
							GameTooltip:Show();
							GameTooltip:FadeOut();
						end)
	_G[TotemBarScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[TotemBarScaleSlider:GetName().."High"]:SetText("2");
	_G[TotemBarScaleSlider:GetName().."Text"]:SetText("Totem Bar:   "..Semi_TotemBar_Scale);
	TotemBarScaleSlider:Show();
end

function Semi_Support_PlayerXPBar_Slider()
	CreateFrame("Slider", "SemiSupportPlayerXPBarSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	SemiSupportPlayerXPBarSlider:ClearAllPoints();
	if (Semiclass == "Shaman") then
		SemiSupportPlayerXPBarSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -200);
	else
		SemiSupportPlayerXPBarSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -150);
	end
	SemiSupportPlayerXPBarSlider:SetMinMaxValues(0.5, 2);
	SemiSupportPlayerXPBarSlider:SetValueStep(0.1);
	SemiSupportPlayerXPBarSlider:SetValue(Semi_Support_PlayerXPBar_Scale);
	SemiSupportPlayerXPBarSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 1);
									self:SetValue(new_value);
									Semi_Support_PlayerXPBar_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_LEFT");
									GameTooltip:SetText(new_value);
									_G[SemiSupportPlayerXPBarSlider:GetName().."Text"]:SetText("PlayerXPBar: "..Semi_Support_PlayerXPBar_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[SemiSupportPlayerXPBarSlider:GetName().."Low"]:SetText("0.5");
	_G[SemiSupportPlayerXPBarSlider:GetName().."High"]:SetText("2");
	_G[SemiSupportPlayerXPBarSlider:GetName().."Text"]:SetText("PlayerXPBar: "..Semi_Support_PlayerXPBar_Scale);
	SemiSupportPlayerXPBarSlider:Show();
end

function Semi_Player_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_Player_Scale = PassedValueFromSliderOrEvent;
	PlayerFrame:SetScale(Semi_Player_Scale);
	if (Semiclass == "Death Knight") then
			--RuneFrame:ClearAllPoints();
			RuneFrame:SetScale(Semi_Player_Scale);
			RuneFrame:SetPoint("BOTTOM", "PlayerFrame", "BOTTOM");
	end
end	

function Semi_Pet_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_Pet_Scale = PassedValueFromSliderOrEvent;
	PetFrame:SetScale(Semi_Pet_Scale);
end

function Semi_Target_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_Target_Scale = PassedValueFromSliderOrEvent;
	TargetFrame:SetScale(Semi_Target_Scale);
end

function Semi_ToT_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_ToT_Scale = PassedValueFromSliderOrEvent;
	TargetFrameToT:SetScale(Semi_ToT_Scale);
end

function Semi_PartyFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_PartyFrame_Scale = PassedValueFromSliderOrEvent;
	PartyMemberFrame1:SetScale(Semi_PartyFrame_Scale);
	PartyMemberFrame2:SetScale(Semi_PartyFrame_Scale);
	PartyMemberFrame3:SetScale(Semi_PartyFrame_Scale);
	PartyMemberFrame4:SetScale(Semi_PartyFrame_Scale);
end

function Semi_FocusFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_FocusFrame_Scale = PassedValueFromSliderOrEvent;
	FocusFrame:SetScale(Semi_FocusFrame_Scale);
end

function Semi_BossTargetFrames_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_BossTargetFrame_Scale = PassedValueFromSliderOrEvent;
	Boss1TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
	Boss2TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
	Boss3TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
	Boss4TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
	--SemiBoss1TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
	--SemiBoss2TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
	--SemiBoss3TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
	--SemiBoss4TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
end

function Semi_All_Bars_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_AllBars_Scale = PassedValueFromSliderOrEvent;
	MainMenuBar:SetScale(Semi_AllBars_Scale);
	MultiBarRight:SetScale(Semi_AllBars_Scale);
	MultiBarLeft:SetScale(Semi_AllBars_Scale);
	VehicleMenuBar:SetScale(Semi_AllBars_Scale*.8);
	if (IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_EB_Bar1:SetScale(Semi_AllBars_Scale);
		Semi_EB_Bar2:SetScale(Semi_AllBars_Scale);
		Semi_EB_Bar3:SetScale(Semi_AllBars_Scale);
	end
end

function Semi_PetBar_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_PetBar_Scale = PassedValueFromSliderOrEvent;
	if (IsAddOnLoaded("Semi_Pet_Bar")) then
		SetPetBarScale(Semi_PetBar_Scale);
	else
		PetActionBarFrame:SetScale(Semi_PetBar_Scale);
	end
end

function Semi_TotemBar_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_TotemBar_Scale = PassedValueFromSliderOrEvent;
	if HasMultiCastActionBar then
		if (IsAddOnLoaded("Semi_Action_Bars")) then
			if (SemiTotemBar) then
				SemiTotemBar:SetScale(Semi_TotemBar_Scale);
			end
		else		
			MultiCastActionBarFrame:SetScale(Semi_TotemBar_Scale);
		end
	end
end

function Semi_Support_PlayerXPBar_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_Support_PlayerXPBar_Scale = PassedValueFromSliderOrEvent;
	PlayerXPBar:SetScale(Semi_Support_PlayerXPBar_Scale);
end

function semi_round(tempnumber, decimals)
	return (("%%.%df"):format(decimals)):format(tempnumber)
end

function Semi_Bags_Options()
	SF_Bags_State = Semi_CoreOptionsCheckButton1:GetChecked() or false;
	if (SF_Bags_State) then
		ShowSemiBags();
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
		Semi_LinkInventoryBagsToDragButton();
	end
	if (not SF_Bags_State) then
		HideSemiBags();
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
	end
end

function Semi_MicroMenu_Options()
	SF_MicroMenu_State = Semi_CoreOptionsCheckButton2:GetChecked() or false;
	if (SF_MicroMenu_State) then
		ShowSemiMenu();
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
		Semi_LinkMicroMenuToDragButton();
	end
	if (not SF_MicroMenu_State) then
		HideSemiMenu();
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
	end
end

function Semi_MainMenuArtTexture_Options()
	SF_MainMenuBarTexture_State = Semi_CoreOptionsCheckButton12:GetChecked() or false;
	if (SF_MainMenuBarTexture_State) then
		Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12a);
		MainMenuBarTexture0:Show();
		MainMenuBarTexture1:Show();
	end
	if (not SF_MainMenuBarTexture_State) then
		Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12b);
		MainMenuBarTexture0:Hide();
		MainMenuBarTexture1:Hide();
	end
end

function Semi_ActionBarPagingButtons_Options()
	SF_ActionPageButtons_State = Semi_CoreOptionsCheckButton13:GetChecked() or false;
	if (SF_ActionPageButtons_State) then
		Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13a);
		ActionBarUpButton:Show();
		ActionBarDownButton:Show();
	end
	if (not SF_ActionPageButtons_State) then
		Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13b);
		ActionBarUpButton:Hide();
		ActionBarDownButton:Hide();
	end
end

function Semi_Party_Options()
	SF_Party_State = Semi_CoreOptionsCheckButton3:GetChecked() or false;
	--[[if (SF_Party_State) then
		PartyMemberFrame1:RegisterAllEvents();
		PartyMemberFrame2:RegisterAllEvents();
		PartyMemberFrame3:RegisterAllEvents();
		PartyMemberFrame4:RegisterAllEvents();
		SF_Party_State = true;

		for p=1, MAX_PARTY_MEMBERS, 1 do
			if ( GetPartyMember(p) ) then
			 _G["PartyMemberFrame"..p]:Show();
			end
		end
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a);
	else
		PartyMemberFrame1:Hide();
		PartyMemberFrame1:UnregisterAllEvents();
		PartyMemberFrame2:Hide();
		PartyMemberFrame2:UnregisterAllEvents();
		PartyMemberFrame3:Hide();
		PartyMemberFrame3:UnregisterAllEvents();
		PartyMemberFrame4:Hide();
		PartyMemberFrame4:UnregisterAllEvents();
		SF_Party_State = false;
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b);
	end
	--]]
		if (SF_Party_State) then
			SF_Party_State = true;
			Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a);
		end
		if (not SF_Party_State) then
			SF_Party_State = false;
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b);
		end
		Semitemp = GetNumRaidMembers();
		if Semitemp == 0 then
			Semiraid = false;
		else
			Semiraid = true;
		end
		if (SF_Party_State) and (not Semiraid) then
			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();

			for p=1, MAX_PARTY_MEMBERS, 1 do
				if ( GetPartyMember(p) ) then
				_G["PartyMemberFrame"..p]:Show();
				end
			end
		end
		if (not SF_Party_State) and (not Semiraid) then
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();
			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();
			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();
			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();
		end
end

function Semi_Raid_Options()
	SF_Raid_State = Semi_CoreOptionsCheckButton11:GetChecked() or false;
	Semitemp = GetNumRaidMembers();
		if Semitemp == 0 then
			Semiraid = false;
		else
			Semiraid = true;
		end
	if (SF_Raid_State) then
		SF_Raid_State = true;
		Semi_CoreOptionsCheckButton11Text:SetText(Semi_Core_String_CB11a);
	end
	if (not SF_Raid_State) then
		SF_Raid_State = false;
		Semi_CoreOptionsCheckButton11Text:SetText(Semi_Core_String_CB11b);
	end
	if (SF_Raid_State) and (Semiraid) then
			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();

			for p=1, MAX_PARTY_MEMBERS, 1 do
				if ( GetPartyMember(p) ) then
				_G["PartyMemberFrame"..p]:Show();
				end
			end
		end
		if (not SF_Raid_State) and (Semiraid) then
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();
			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();
			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();
			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();
		end
end

function Semi_ExtraBar1_Options()
	SF_EB_1_State = Semi_CoreOptionsCheckButton6:GetChecked() or false;
	if (SF_EB_1_State) then
		Semi_Bar1_ShowBar();
		Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6a);
		Semi_Bar1_ActionBar = true;
	end
	if (not SF_EB_1_State) then
		Semi_Bar1_HideBar();
		Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6b);
		Semi_Bar1_ActionBar = false;
	end
end

function Semi_ExtraBar2_Options()
	SF_EB_2_State = Semi_CoreOptionsCheckButton7:GetChecked() or false;
	if (SF_EB_2_State) then
		Semi_Bar2_ShowBar();
		Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7a);
		Semi_Bar2_ActionBar = true;
	end
	if (not SF_EB_2_State) then
		Semi_Bar2_HideBar();
		Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7b);
		Semi_Bar2_ActionBar = false;
	end
end

function Semi_ExtraBar3_Options()
	SF_EB_3_State = Semi_CoreOptionsCheckButton8:GetChecked() or false;
	if (SF_EB_3_State) then
		Semi_Bar3_ShowBar();
		Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8a);
		Semi_Bar3_ActionBar = true;
	end
	if (not SF_EB_3_State) then
		Semi_Bar3_HideBar();
		Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8b);
		Semi_Bar3_ActionBar = false;
	end
end

function Semi_Grid_Choice_Options()
	SF_Grid_State = Semi_CoreOptionsCheckButton9:GetChecked() or false;
	Semi_Grid = SF_Grid_State;
	if (SF_Grid_State) then
		Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9a);
	end
	if (not SF_Grid_State) then
		Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9b);
	end
	Semi_GridChoice();
end

function Semi_Extra_Bars_Vehicle_Alpha_Choice()
	SF_EB_Vehicle_Alpha_State = Semi_CoreOptionsCheckButton10:GetChecked() or false;
	Semi_Show_Bars_In_Vehicle = SF_EB_Vehicle_Alpha_State;
	if (SF_EB_Vehicle_Alpha_State) then
		Semi_CoreOptionsCheckButton10Text:SetText(Semi_Core_String_CB10a);
	end
	if (not SF_EB_Vehicle_Alpha_State) then
		Semi_CoreOptionsCheckButton10Text:SetText(Semi_Core_String_CB10b);
	end
end

function Semi_Frames_Unlock()
	if ( Semicombat == false ) then
		SemiVehicleLeaveDragButton:Show();
		SemiPlayerPowerBarAltDragButton:Show();
		SemiExtraActionButtonDragButton:Show();
		if (SF_Castbar_State) then
			SemiCastingBarDragButton:Show();
		end
		-- if (IsAddOnLoaded("Semi_Pet_Frame")) then
		--	SF_Pet_Locked = false;
		--	SF_PetFrameDragButton:Show();
		-- end
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
			SF_TargetofTarget_Locked = false;
			SFTOTTargetofTargetFrameDragButton:Show();
		end
		if (IsAddOnLoaded("Semi_Action_Bars")) then
			if (Semiclass == "Shaman" and HasMultiCastActionBar) then
				Semi_LinkTotemBarToDragButton();
				SemiTotemBarDragButton:Show();
			end
			
			Semi_LinkMainMenuBarToDragButton();
			Semi_LinkBottomLeftBarToDragButton();
			Semi_LinkBottomRightBarToDragButton();
			Semi_LinkMicroMenuToDragButton();
			Semi_LinkInventoryBagsToDragButton();
			
			SemiMainMenuBarDragButton:Show();
			SemiBottomLeftBarDragButton:Show();
			SemiBottomRightBarDragButton:Show();
			SemiInventoryBagsDragButton:Show();
			SemiMicroMenuDragButton:Show();
			
		end	
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			if (Semi_Bar1_ActionBar) then
				Semi_Bar1_UnLockBars();
			end
			if (Semi_Bar2_ActionBar) then
				Semi_Bar2_UnLockBars();
			end
			if (Semi_Bar3_ActionBar) then
				Semi_Bar3_UnLockBars();
			end
		end
		if (IsAddOnLoaded("Semi_Pet_Bar")) then
			if SemiPetBar:IsShown() then
				Semi_Pet_Bar_UnLockBars();
			end
			--if Semiclass == "Priest" then
			--	PetActionBarFrame:Show();
			--end
		end
		if (IsAddOnLoaded("Semi_Stance_Bar")) then
			if ShapeshiftButton1:IsShown() then
				SemiStanceBar_UnLockBars();
			end
		end
		if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
			SemiGroupLootFrameDragButton:Show();
		end
		if (IsAddOnLoaded("Semi_Boss_Frames")) then
			Semi_LinkBossFramesButtonToDragButton();
			SemiBossFramesDragButton:SetAlpha(1);
			SemiBossFramesDragButton:EnableMouse("true");
		end
		
	else
		DEFAULT_CHAT_FRAME:AddMessage("You can't unlock the frames during combat!");
	end

end

function Semi_Frames_Lock()
	if ( Semicombat == false ) then
		SemiCastingBarDragButton:Hide();
		SemiVehicleLeaveDragButton:Hide();
		SemiPlayerPowerBarAltDragButton:Hide();
		SemiExtraActionButtonDragButton:Hide();
		if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
			SemiGroupLootFrameDragButton:Hide();
		end
		
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
			SF_TargetofTarget_Locked = true;
			SFTOTTargetofTargetFrameDragButton:Hide();
		end
		if (IsAddOnLoaded("Semi_Action_Bars")) then
			SemiMainMenuBarDragButton:Hide();
			SemiBottomLeftBarDragButton:Hide();
			SemiBottomRightBarDragButton:Hide();
			SemiInventoryBagsDragButton:Hide();
			SemiMicroMenuDragButton:Hide();
			if (Semiclass == "Shaman" and HasMultiCastActionBar) then
				SemiTotemBarDragButton:Hide();
			end
		end	
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			if (Semi_Bar1_ActionBar) then
				Semi_Bar1_LockBars();
			end
			if (Semi_Bar2_ActionBar) then
				Semi_Bar2_LockBars();
			end
			if (Semi_Bar3_ActionBar) then
				Semi_Bar3_LockBars();
			end
		end
		if (IsAddOnLoaded("Semi_Pet_Bar")) then
			if SemiPetBar:IsShown() then
				Semi_Pet_Bar_LockBars();
			end
			--if Semiclass == "Priest" then
				--Semi_Pet_Bar_LockBars();
			--end
		end
		if (IsAddOnLoaded("Semi_Stance_Bar")) then
			if ShapeshiftButton1:IsShown() then
				SemiStanceBar_LockBars();
			end
		end
		if (IsAddOnLoaded("Semi_Boss_Frames")) then
			SemiBossFramesDragButton:SetAlpha(0);
			SemiBossFramesDragButton:EnableMouse("false");
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("You can't lock the frames during combat!");
	end
	
end

function Semi_LinkCastingBarToDragButton()
	if ( SF_Castbar_State ) then
		UIPARENT_MANAGED_FRAME_POSITIONS["CastingBarFrame"] = nil;
		CastingBarFrame:ClearAllPoints();
		CastingBarFrame:SetPoint("BOTTOMLEFT", SemiCastingBarDragButton, "BOTTOMLEFT");
	end
end

function Semi_Castbar_Options()
	SF_Castbar_State = Semi_CoreOptionsCheckButton4:GetChecked() or false;
	
		if ( SF_Castbar_State ) then
			CastingBarFrame:RegisterAllEvents();
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
			Semi_LinkCastingBarToDragButton();
		elseif (not SF_Castbar_State ) then
			CastingBarFrame:Hide();
			CastingBarFrame:UnregisterAllEvents();
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
			SemiCastingBarDragButton:Hide();
		end
	
	
end

function Semi_Gryphons_Options()
	SF_Gryphon_State = Semi_CoreOptionsCheckButton5:GetChecked() or false;
	
	if ( SF_Gryphon_State ) then
		MainMenuBarLeftEndCap:Show();
		MainMenuBarRightEndCap:Show();
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
	elseif (not SF_Gryphon_State) then
		MainMenuBarLeftEndCap:Hide();
		MainMenuBarRightEndCap:Hide();
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
	end
end

function Semi_LinkVehicleLeaveButtonToDragButton()
	if (not Semicombat) then
		MainMenuBarVehicleLeaveButton:ClearAllPoints();
		MainMenuBarVehicleLeaveButton:SetPoint("BOTTOMLEFT", SemiVehicleLeaveDragButton, "BOTTOMLEFT");
	end
end
hooksecurefunc("MainMenuBarVehicleLeaveButton_Update", Semi_LinkVehicleLeaveButtonToDragButton);

function Semi_LinkPowerBarAltButtonToDragButton()
	PlayerPowerBarAlt:ClearAllPoints();
	PlayerPowerBarAlt:SetPoint("BOTTOMLEFT", SemiPlayerPowerBarAltDragButton, "BOTTOMLEFT");
end

function Semi_LinkExtraActionButtonToDragButton()
	ExtraActionButton1:ClearAllPoints();
	ExtraActionButton1:SetPoint("BOTTOM", SemiExtraActionButtonDragButton, "BOTTOM");
end

  --Functions for the Modules Menu

--[[ 
function Semi_BossTargetFrame_Load_Options()
	SF_BossTargetFrame_Load = Semi_CoreOptions_ModsCheckButton1:GetChecked() or false;
	if (SF_BossTargetFrame_Load) and (IsAddOnLoaded("Semi_Boss_Frames")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	end
	if (not SF_BossTargetFrame_Load) and (not IsAddOnLoaded("Semi_Boss_Frames")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1b);
	end
	if (SF_BossTargetFrame_Load) and (not IsAddOnLoaded("Semi_Boss_Frames")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1c);
	end
	if (not SF_BossTargetFrame_Load) and (IsAddOnLoaded("Semi_Boss_Frames")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1d);
	end
end

function Semi_TargetFrame_Load_Options()
	SF_TargetFrame_Load = Semi_CoreOptions_ModsCheckButton2:GetChecked() or false;
	if (SF_TargetFrame_Load) and (IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	end
	if (not SF_TargetFrame_Load) and (not IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2b);
	end
	if (SF_TargetFrame_Load) and (not IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2c);
	end
	if (not SF_TargetFrame_Load) and (IsAddOnLoaded("Semi_Target_Frame")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2d);
	end
end
--]]

function Semi_TargetFrameToT_Load_Options()
	SF_TargetFrameToT_Load = Semi_CoreOptions_ModsCheckButton3:GetChecked() or false;
	if (SF_TargetFrameToT_Load) and (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	end
	if (not SF_TargetFrameToT_Load) and (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3b);
	end
	if (SF_TargetFrameToT_Load) and (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3c);
	end
	if (not SF_TargetFrameToT_Load) and (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3d);
	end
end

function Semi_Portrait_Options()
	SF_ClassIcons_Portrait = Semi_CoreOptions_ModsCheckButton4:GetChecked() or false;
	if (SF_ClassIcons_Portrait) and (IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	end
	if (not SF_ClassIcons_Portrait) and (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4b);
	end
	if (SF_ClassIcons_Portrait) and (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4c);
	end
	if (not SF_ClassIcons_Portrait) and (IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4d);
	end
end

function Semi_Action_Bars_Options()
	SF_ActionBars_Load = Semi_CoreOptions_ModsCheckButton5:GetChecked() or false;
	if (SF_ActionBars_Load) and (IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	end
	if (not SF_ActionBars_Load) and (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5b);
	end
	if (SF_ActionBars_Load) and (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5c);
	end
	if (not SF_ActionBars_Load) and (IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5d);
	end
end

function Semi_Extra_Bars_Options()
	SF_ExtraBars_Load = Semi_CoreOptions_ModsCheckButton6:GetChecked() or false;
	if (SF_ExtraBars_Load) and (IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	end
	if (not SF_ExtraBars_Load) and (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6b);
	end
	if (SF_ExtraBars_Load) and (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6c);
	end
	if (not SF_ExtraBars_Load) and (IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6d);
	end
end

function Semi_Pet_Bar_Options()
	SF_PetBar_Load = Semi_CoreOptions_ModsCheckButton7:GetChecked() or false;
	if (SF_PetBar_Load) and (IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	end
	if (not SF_PetBar_Load) and (not IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7b);
	end
	if (SF_PetBar_Load) and (not IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7c);
	end
	if (not SF_PetBar_Load) and (IsAddOnLoaded("Semi_Pet_Bar")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7d);
	end
end

function Semi_Stance_Bar_Options()
	SF_StanceBar_Load = Semi_CoreOptions_ModsCheckButton8:GetChecked() or false;
	if (SF_StanceBar_Load) and (IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	end
	if (not SF_StanceBar_Load) and (not IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8b);
	end
	if (SF_StanceBar_Load) and (not IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8c);
	end
	if (not SF_StanceBar_Load) and (IsAddOnLoaded("Semi_Stance_Bar")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8d);
	end
end

function Semi_GroupLoot_Frame_Options()
	SF_GroupLoot_Load = Semi_CoreOptions_ModsCheckButton9:GetChecked() or false;
	if (SF_GroupLoot_Load) and (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9a);
	end
	if (not SF_GroupLoot_Load) and (not IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9b);
	end
	if (SF_GroupLoot_Load) and (not IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9c);
	end
	if (not SF_GroupLoot_Load) and (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9d);
	end
end

function Semi_CoreOptions_Mods_ReloadUI()
	local mod1, mod2, mod3, mod4, mod5, mod6, mod7, mod8, mod9;
	mod1 = Semi_CoreOptions_ModsCheckButton1:GetChecked() or false;
	mod2 = Semi_CoreOptions_ModsCheckButton2:GetChecked() or false;
	mod3 = Semi_CoreOptions_ModsCheckButton3:GetChecked() or false;
	mod4 = Semi_CoreOptions_ModsCheckButton4:GetChecked() or false;
	mod5 = Semi_CoreOptions_ModsCheckButton5:GetChecked() or false;
	mod6 = Semi_CoreOptions_ModsCheckButton6:GetChecked() or false;
	mod7 = Semi_CoreOptions_ModsCheckButton7:GetChecked() or false;
	mod8 = Semi_CoreOptions_ModsCheckButton8:GetChecked() or false;
	mod9 = Semi_CoreOptions_ModsCheckButton9:GetChecked() or false;
	
	--if (not mod1) then
		--DisableAddOn("Semi_Boss_Frames");
	--elseif (mod1) then
		--EnableAddOn("Semi_Boss_Frames");
		--LoadAddOn("Semi_Boss_Frames");
	--end

	--if (not mod2) then
	--	DisableAddOn("Semi_Target_Frame");
	--elseif (mod2) then
	--	EnableAddOn("Semi_Target_Frame");
	--	LoadAddOn("Semi_Target_Frame");
	--end

	if (not mod3) then
		DisableAddOn("Semi_TargetofTarget_Frame");
	elseif (mod3) then
		EnableAddOn("Semi_TargetofTarget_Frame");
		LoadAddOn("Semi_TargetofTarget_Frame");
	end

	if  (not mod4) then
		DisableAddOn("Semi_ClassIcons_Portrait");
	elseif (mod4) then
		EnableAddOn("Semi_ClassIcons_Portrait");
		LoadAddOn("Semi_ClassIcons_Portrait");
	end
	
	if (not mod5) then
		DisableAddOn("Semi_Action_Bars");
	elseif (mod5) then
		EnableAddOn("Semi_Action_Bars");
		LoadAddOn("Semi_Action_Bars");
	end
	
	if (not mod6) then
		DisableAddOn("Semi_Extra_Bars");
	elseif (mod6) then
		EnableAddOn("Semi_Extra_Bars");
		LoadAddOn("Semi_Extra_Bars");
	end
	
	if (not mod7) then
		DisableAddOn("Semi_Pet_Bar");
	elseif (mod7) then
		EnableAddOn("Semi_Pet_Bar");
		LoadAddOn("Semi_Pet_Bar");
	end
	if (not mod8) then
		DisableAddOn("Semi_Stance_Bar");
	elseif (mod8) then
		EnableAddOn("Semi_Stance_Bar");
		LoadAddOn("Semi_Stance_Bar");
	end
	if (not mod9) then
		DisableAddOn("Semi_GroupLoot_Frame");
	elseif (mod9) then
		EnableAddOn("Semi_GroupLoot_Frame")
		LoadAddOn("Semi_GroupLoot_Frame");
	end
	ReloadUI();
end





function Semi_Core_CleanUp()
  	if (IsAddOnLoaded("Semi_Pet_Bar")) and (not Semicombat) then
		if SemiPetBar:IsShown() then
			Semi_Pet_Bar_LockBars();
		end
	end
	if (not Semicombat) then
		Semi_Frames_Lock();
	elseif (Semicombat) then          --Need to put in the check for modules and to alpha out the drag buttons they possess
		--if ((SF_Player_Locked == false) or (SF_Target_Locked == false) or (SF_TargetofTarget_Locked == false)) then
			--DEFAULT_CHAT_FRAME:AddMessage("The Options screen will open after leaving combat");
		--end
		--if (SF_Player_Locked == false) then
		--	DEFAULT_CHAT_FRAME:AddMessage("Player Frame is not locked in place, you can still move it");
		--end
		--if (SF_Target_Locked == false) then
		--	DEFAULT_CHAT_FRAME:AddMessage("Target Frame is not locked in place, you can still move it");
		--end
		if SemiPlayerPowerBarAltDragButton:IsShown() then
			DEFAULT_CHAT_FRAME:AddMessage("Your drag buttons are not locked in place, Options screen will open after combat");
		--if (SF_TargetofTarget_Locked == false) then
			--DEFAULT_CHAT_FRAME:AddMessage("Target of Target Frame is not locked in place, you can still move it");
		end
	end
end


function Semi_Core_OnEvent(self, event, ...)
	if ( event == "PLAYER_REGEN_DISABLED" ) then
		Semicombat = true;
		SemiCastingBarDragButton:SetAlpha(0.1);
		SemiVehicleLeaveDragButton:SetAlpha(0.1);
		SemiPlayerPowerBarAltDragButton:SetAlpha(0.1);
		SemiExtraActionButtonDragButton:SetAlpha(0.1);
		if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
			SemiGroupLootFrameDragButton:SetAlpha(0);
		end
	--[[	
		if (IsAddOnLoaded("Semi_Player_Frame")) then
			SPF_PlayerFrameDragButton:SetAlpha(0.1);
		end
		if (IsAddOnLoaded("Semi_Target_Frame")) then
			SFTTargetFrameDragButton:SetAlpha(0.1);
		end
	--]]
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then		
			SFTOTTargetofTargetFrameDragButton:SetAlpha(0.1);
		end
		if (IsAddOnLoaded("Semi_Boss_Frames")) then
			SemiBossFramesDragButton:SetAlpha(0.1);
		end
		if Semi_CoreOptions:IsShown() then
			Semi_CoreOptions:Hide();
		end
		if Semi_CoreOptions_Mods:IsShown() then
			Semi_CoreOptions_Mods:Hide();
		end
		if Semi_ScaleOptions:IsShown() then
			Semi_ScaleOptions:Hide();
		end
	end
	if ( event == "PLAYER_REGEN_ENABLED") then
		Semicombat = false;
		SemiCastingBarDragButton:SetAlpha(1);
		SemiVehicleLeaveDragButton:SetAlpha(1);
		SemiPlayerPowerBarAltDragButton:SetAlpha(1);
		SemiExtraActionButtonDragButton:SetAlpha(1);
		if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
			SemiGroupLootFrameDragButton:SetAlpha(1);
		end
	--[[
		if (IsAddOnLoaded("Semi_Player_Frame")) then
			SPF_PlayerFrameDragButton:SetAlpha(.7);
		end
		if (IsAddOnLoaded("Semi_Target_Frame")) then
			SFTTargetFrameDragButton:SetAlpha(.7);
		end
	--]]
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
			SFTOTTargetofTargetFrameDragButton:SetAlpha(.7);
		end
		if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
			Semi_LinkGroupLootFrameButtonToDragButton();
		end
		if(IsAddOnLoaded("Semi_Boss_Frames")) then
			Semi_LinkBossFramesButtonToDragButton();
		end
		if (SemiPlayerPowerBarAltDragButton:IsShown()) then
			Semi_CoreOptions:Show();
		end
		if ( SF_Castbar_State ) then
			Semi_LinkCastingBarToDragButton();
		end
		Semi_LinkVehicleLeaveButtonToDragButton();
		Semi_LinkExtraActionButtonToDragButton();
		if (not UnitInVehicle("player")) then
			--Semi_LinkVehicleLeaveButtonToDragButton();
			Semi_LinkPowerBarAltButtonToDragButton();
			Semi_Player_Scale_On_Change(Semi_Player_Scale);
			Semi_Pet_Scale_On_Change(Semi_Pet_Scale);
			Semi_Target_Scale_On_Change(Semi_Target_Scale);
			Semi_ToT_Scale_On_Change(Semi_ToT_Scale);
			Semi_PartyFrame_Scale_On_Change(Semi_PartyFrame_Scale);
			Semi_FocusFrame_Scale_On_Change(Semi_FocusFrame_Scale);
			Semi_All_Bars_Scale_On_Change(Semi_AllBars_Scale);
			Semi_PetBar_Scale_On_Change(Semi_PetBar_Scale);
			Semi_BossTargetFrames_Scale_On_Change(Semi_BossTargetFrame_Scale);
			if ( Semiclass == "Shaman" ) then
				Semi_TotemBar_Scale_On_Change(Semi_TotemBar_Scale);
			end
			if (IsAddOnLoaded("PlayerXPBar")) then
				Semi_Support_PlayerXPBar_Scale_On_Change(Semi_Support_PlayerXPBar_Scale);
			end
		end
	end
	if ( event == "ADDON_LOADED" or event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_LOGIN") then
		--Change to test the other changes --Start--
		Semitemp = GetNumRaidMembers();
		if Semitemp == 0 then
			Semiraid = false;
		else
			Semiraid = true;
		end
		-- End of Change Testing		
		
		
		
		
		Semi_LinkPowerBarAltButtonToDragButton();
		Semi_LinkVehicleLeaveButtonToDragButton();
		Semi_LinkExtraActionButtonToDragButton();
		
		SemiCastingBarDragButton:Hide();
		SemiVehicleLeaveDragButton:Hide();
		SemiPlayerPowerBarAltDragButton:Hide();
		SemiExtraActionButtonDragButton:Hide();
		
		Semi_Core_MinimapButton_Reposition();
		Semicombat = false;
		
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			Semi_Bar1_LockBars();
			Semi_Bar2_LockBars();
			Semi_Bar3_LockBars();
		end
		if ( SF_Castbar_State ) then
			Semi_LinkCastingBarToDragButton();
		elseif (not SF_Castbar_State ) then
			CastingBarFrame:Hide();
			CastingBarFrame:UnregisterAllEvents();
		end
		if (not SF_Gryphon_State) then
			MainMenuBarLeftEndCap:Hide();
			MainMenuBarRightEndCap:Hide();
		elseif (SF_Gryphon_State) then
			MainMenuBarLeftEndCap:Show();
			MainMenuBarRightEndCap:Show();
		end
		--[[
		if (SF_Party_State) then
			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();

			for p=1, MAX_PARTY_MEMBERS, 1 do
				if ( GetPartyMember(p) ) then
				_G["PartyMemberFrame"..p]:Show();
				end
			end
		end
		if (not SF_Party_State) then
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();
			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();
			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();
			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();
		end
		--]]
		if (SF_Party_State) and (not Semiraid) then
			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();

			for p=1, MAX_PARTY_MEMBERS, 1 do
				if ( GetPartyMember(p) ) then
				_G["PartyMemberFrame"..p]:Show();
				end
			end
		end
		if (not SF_Party_State) and (not Semiraid) then
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();
			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();
			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();
			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();
		end
		if (SF_Raid_State) and (Semiraid) then
			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();

			for p=1, MAX_PARTY_MEMBERS, 1 do
				if ( GetPartyMember(p) ) then
				_G["PartyMemberFrame"..p]:Show();
				end
			end
		end
		if (not SF_Raid_State) and (Semiraid) then
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();
			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();
			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();
			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();
		end
		Semi_Player_Scale_On_Change(Semi_Player_Scale);
		Semi_Pet_Scale_On_Change(Semi_Pet_Scale);
		Semi_Target_Scale_On_Change(Semi_Target_Scale);
		Semi_ToT_Scale_On_Change(Semi_ToT_Scale);
		Semi_PartyFrame_Scale_On_Change(Semi_PartyFrame_Scale);
		Semi_FocusFrame_Scale_On_Change(Semi_FocusFrame_Scale);
		--if (IsAddOnLoaded("Semi_Boss_Frames")) then
			Semi_BossTargetFrames_Scale_On_Change(Semi_BossTargetFrame_Scale);
		--end
		Semi_All_Bars_Scale_On_Change(Semi_AllBars_Scale);
		Semi_PetBar_Scale_On_Change(Semi_PetBar_Scale);
		Semi_BossTargetFrames_Scale_On_Change(Semi_BossTargetFrame_Scale);
		if ( Semiclass == "Shaman" ) then
			Semi_TotemBar_Scale_On_Change(Semi_TotemBar_Scale);
		end
		if (IsAddOnLoaded("PlayerXPBar")) and (event == "PLAYER_ENTERING_WORLD") then
			Semi_Support_PlayerXPBar_Scale_On_Change(Semi_Support_PlayerXPBar_Scale);
		end
	end
	if (event == "UNIT_EXITING_VEHICLE") and (not UnitHasVehicleUI("player")) and (not Semicombat) then
		Semi_Player_Scale_On_Change(Semi_Player_Scale);
		Semi_Pet_Scale_On_Change(Semi_Pet_Scale);
		Semi_Target_Scale_On_Change(Semi_Target_Scale);
		Semi_ToT_Scale_On_Change(Semi_ToT_Scale);
		Semi_PartyFrame_Scale_On_Change(Semi_PartyFrame_Scale);
		Semi_FocusFrame_Scale_On_Change(Semi_FocusFrame_Scale);
		Semi_All_Bars_Scale_On_Change(Semi_AllBars_Scale);
		Semi_PetBar_Scale_On_Change(Semi_PetBar_Scale);
		--if (IsAddOnLoaded("Semi_Boss_Frames")) then
			Semi_BossTargetFrames_Scale_On_Change(Semi_BossTargetFrame_Scale);
		--end
		if ( Semiclass == "Shaman" ) then
			Semi_TotemBar_Scale_On_Change(Semi_TotemBar_Scale);
		end
		if (IsAddOnLoaded("PlayerXPBar")) then
			Semi_Support_PlayerXPBar_Scale_On_Change(Semi_Support_PlayerXPBar_Scale);
		end		
	end

	if (event == "PLAYER_LEVEL_UP") then
		Semilevel = Semilevel + 1;
		--DEFAULT_CHAT_FRAME:AddMessage("Congrats on getting level "..Semilevel..);
	end
	if ((event == "RAID_ROSTER_UPDATE") or (event == "PARTY_CONVERTED_TO_RAID") or (event == "PARTY_MEMBERS_CHANGED")) and (not Semicombat) then
		Semitemp = GetNumRaidMembers();
		if Semitemp == 0 then
			Semiraid = false;
		else
			Semiraid = true;
		end
		if (SF_Party_State) and (not Semiraid) then
			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();

			for p=1, MAX_PARTY_MEMBERS, 1 do
				if ( GetPartyMember(p) ) then
				_G["PartyMemberFrame"..p]:Show();
				end
			end
		end
		if (not SF_Party_State) and (not Semiraid) then
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();
			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();
			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();
			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();
		end
		if (SF_Raid_State) and (Semiraid) then
			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();

			for p=1, MAX_PARTY_MEMBERS, 1 do
				if ( GetPartyMember(p) ) then
				_G["PartyMemberFrame"..p]:Show();
				end
			end
		end
		if (not SF_Raid_State) and (Semiraid) then
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();
			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();
			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();
			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();
		end
	end
end

function Semi_Core_MinimapButton_Reposition()
	if (Semi_Core_MinimapPos == "" or Semi_Core_MinimapPos == "nil" or Semi_Core_MinimapPos == nil) then
		Semi_Core_MinimapPos = 45;
	end
	Semi_CoreMinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(Semi_Core_MinimapPos)),(80*sin(Semi_Core_MinimapPos))-52);
end

function Semi_CoreMinimapButton_DraggingFrame_OnUpdate()

	local xpos, ypos = GetCursorPosition();
	local xmin = Minimap:GetLeft();
	local ymin = Minimap:GetBottom();

	xpos = (xmin-xpos/UIParent:GetScale()+70); -- get coordinates as differences from the center of the minimap
	ypos = (ypos/UIParent:GetScale()-ymin-70);

	Semi_Core_MinimapPos = (math.deg(math.atan2(ypos,xpos))); -- save the degrees we are relative to the minimap center
	Semi_Core_MinimapButton_Reposition(); -- move the button
end

function Semi_CoreMinimapButton_LeftClick()
		if ( Semicombat == false ) then
			if (Semi_ScaleOptions:IsShown()) then
				Semi_ScaleOptions:Hide();
			end
			if (Semi_CoreOptions_Mods:IsShown()) then
				Semi_CoreOptions_Mods:Hide();
			end
			if  (Semi_CoreOptions:IsShown()) then
				Semi_CoreOptions:Hide();
			else 
				Semi_CoreOptions:Show();
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("You can't open the Main Menu Screen during combat!");
		end
end

function Semi_CoreMinimapButton_RightClick()
		if (not Semicombat) then
			if (Semi_CoreOptions:IsShown()) then
				Semi_CoreOptions:Hide();
			end
			if (Semi_ScaleOptions:IsShown()) then
				Semi_ScaleOptions:Hide();
			end
			if (Semi_CoreOptions_Mods:IsShown()) then
				Semi_CoreOptions_Mods:Hide();
			else 
				Semi_CoreOptions_Mods:Show();
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("You can't open the Module Menu Screen during combat!");
		end
end

function Semi_CoreMinimapButton_Middleclick()
	if (not Semicombat) then
		if  (Semi_CoreOptions:IsShown()) then
			Semi_CoreOptions:Hide();
		end
		if (Semi_CoreOptions_Mods:IsShown()) then
			Semi_CoreOptions_Mods:Hide();
		end
		if (Semi_ScaleOptions:IsShown()) then
			Semi_ScaleOptions:Hide();
		else
			Semi_ScaleOptions:Show();
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("You can't open the Scale Menu Screen during combat!");
	end
end


